#!/usr/bin/perl -w

use Mail::Sendmail;

# the location of the various lists files
$list="/put/here/where/your/lists/files/are/";

# the name and path of the log file (NOTE: must be possible to write)
$logfile="/put/here/the/log/file";

# the local domain to use
$domain="thelocal.dom";

# empty subject line ok (1) or not (0)
$emptysub=0;

# variables used internally
$from="";
$real="";
$ok=0;
$line=0;
$add=0;
$sub="";

# open the log file
open(LOGFILE,">>$logfile") || die("can't open the log file!");

# read the mail one line at a time
ALINE: while(<STDIN>) {

	chomp();

	# analize the "from" part
	if( m/^From: .*$/ ) {

		$from=$_;
		if(m/^From: [^<]*<([^@]*)@.*$/){
			$from =~ s/^From: [^<]*<([^@]*)@.*$/$1/;
		}
		if(m/^From: ([^@]*)@.*$/){
			$from =~ s/^From: ([^@]*)@.*$/$1/;
		}

		open(USER,"/etc/aliases") || 
			die("Can't access the alias list");

		USERS: while(<USER>) {
			chomp();
			if(m/$from/) {
				$real=$_;
				$real=~s/^[^:]*:([^\b]*)$/$1/;
				$real=~s/ //g;
			}
			last USERS if /$from/;
		}
		close(USER);

		if( $real eq "" ) {
			open(USER,"/etc/passwd") || die(
				"Can't open the user list\n");
			USERS: while(<USER>) {
				if(m/$from/) {
					$real=$_;
					$real=~s/^([^:]*):.*$/$1/;
				}
				last USERS if /$from/;
			}
			close(USER);
		}

		if( $real eq "" ) {
			print LOGFILE "$from is not a user here!\n";
			exit 0;
		}
		next ALINE;
	}

	# analize the "to" part...
	if( m/^To: .*$/ ) {

		$to=$_;
		$to=~s/^To: <+([^@]*)@.*$/$1/;
		$list=$list.$to.".lst";

		if(! -r $list) {
			print LOGFILE "There is no \"$list\" list here!\n";
			exit 0;
		} else {
			open(LIST,"$list") ||
				die("Can't open the list file $list\n");
			LIST: while(<LIST>) {
				chomp();
				if(m/$real/) {
					$ok=1;
				}
				last LIST if /$real/;
			}
			close(LIST);
		}
		next ALINE;
	}

	# save the subject
	if(m/Subject: .*/) {
		$sub=$_;
		$sub=~s/Subject: (.*)$/$1/;
		next ALINE;
	}
	
	# save the body
	if(m/^$/) {
		$add=1;
		next ALINE;
	}
	if($add == 1) { $orig[$line++]="$_\n"; }
}

# allow empty subject line?
if($emptysub==0) {
	if($sub eq "") {
		print LOGFILE "No subject line in the message from $from\n";
		exit 0;
	}
}

if($ok==1) {
	# Ok, now send the mails
	open(LIST,"$list") || die("Can't open mailing list $list");
	while(<LIST>) {
		chomp();
		print("$_\n");
		%mail=(
			From => "$to\@$domain",
			To => "$_\@$domain",
			Subject => "$sub",
			Message => "@orig"
		);
		$mail{'X-Loop'}="Some";
		if( ! sendmail %mail) {
			print LOGFILE "Error sending mail to $_:
			$Mail::Sendmail::error!";
		}
	}
	close(LIST);
} else {
	print LOGFILE "User \"$from\" forbidden to post to the list $to\n";
}

exit 0;
